proc Face:Get:YMPdrSot { } {
    global FACE

    set m [GetMonthInt [lindex $FACE(head_tmonth_year) 0]]
    set y [lindex $$FACE(head_tmonth_year) 1]
    if { [set idx [$FACE(pdrwindow) getvalue]] == -1 } {
        set pdr_cod -1
    } else {
        set pdr_cod [lindex $FACE(lpdr_cod) $idx]
    }
    if { [set idx [$FACE(mclwindow) curselection]] >= 0 } { 
        set sot_cod [lindex [$FACE(mclwindow) get $idx] 2]
    } else {
        set sot_cod -1
    }
    return "$y $m $pdr_cod $sot_cod"
}


proc Face:Sel { } {
    global MAIN FACE
    BeforeQuery FACE "    ... "
    
    set wmcl $FACE(mclwindow)
    if { [set oldidx [$wmcl curselection]] < 0 } { set oldidx 0 }
    $wmcl delete 0 end
    
    Lindexes [Face:Get:YMPdrSot] y m pdr_cod sot_cod
    set i 0
    set query "select distinct a.sot_cod, a.tn, a.fio, 
                      sotsaldo(a.sot_cod,$y,$m) as saldo
                   from sotdolpdr a
                   where a.pdr_cod = $pdr_cod and
                         a.dt = (select max(y.dt) from sotdol y 
                                    where y.sot_cod = a.sot_cod and
                                          y.dt < '[GetFirstDayNextMonth $m $y]') and
                         ( a.du is null or a.du > '01.$m.$y' )
                   group by a.sot_cod, a.tn, a.fio
                   order by a.tn"
    dpg_select .face $MAIN(iddbs) $query A {
        $wmcl insert end [list [cnvs $A(tn)] [cnvs $A(fio)] $A(sot_cod) $A(saldo)]
        ProgressIncr FACE(progress) [incr i] 20
    } 
    
    if { [incr i -1] < $oldidx } { set oldidx $i }
    $FACE(monthyearwindow) configure -values [YearAmongMonth $FACE(head_tmonth_year)]
    AfterQuery FACE
    SelectionActivateSee $wmcl $oldidx
    focus $wmcl
    Face:Import:Attr $wmcl
}

proc Face:Print { flg } {
    global FACE
    Lindexes [Face:Get:YMPdrSot] y m pdr_cod sot_cod
    if $flg {
        set sot_cod -1 
    } else {
        set pdr_cod -1
    }
    if { [set idx [$FACE(mclwindow) curselection]] >= 0 } { 
        set fio [lindex [$FACE(mclwindow) get $idx] 1]
    } else {
        set fio ""
    }
    Face:Report .face FACE $FACE(head_tmonth_year) $y $m $pdr_cod \
                $FACE(head_pdr_nam) $sot_cod $fio
}

proc Face:Report { tpl glv tmonthyear y m pdr_cod pdr_nam sot_cod fio } {
    global MAIN $glv
    if { $pdr_cod == -1 && $sot_cod == -1 } {
        set msg ""
        set sotqr 1=1
        set pdrqr 1=1
        set repfile faceorg
    } else {
        if { $pdr_cod == -1 } {
            set msg $fio
            set sotqr "a.sot_cod = $sot_cod"
            set pdrqr 1=1
            set repfile facesot
        } else {
            set msg " $pdr_nam"
            set sotqr 1=1
            set pdrqr "a.pdr_cod = $pdr_cod"
            set repfile facepdr
        }
    }
    
    set query "select distinct a.sot_cod, a.tn, a.fio, a.pdr_cod, a.pdr_nam, 
                      sotsaldo(a.sot_cod,$y,$m) as saldob
                 from sotdolpdr a
                 where $pdrqr and
                       $sotqr and
                       a.dt = (select max(y.dt) from sotdol y 
                                  where y.sot_cod = a.sot_cod and
                                        y.dt < '[GetFirstDayNextMonth $m $y]') and
                                        ( a.du is null or a.du > '01.$m.$y')
                 order by a.pdr_nam, a.fio"

    if ![MessageDlg $tpl.dlg -buttons { } -icon question -type user -message "   \n $msg ?" -default 0] {
        BeforeQuery $glv "   ... "
        report start $repfile
        set i 0
        dpg_select $tpl $MAIN(iddbs) $query A {
            set lstn "{: {}}"
            set lstu "{: {}}"
            set lstv "{: {}}"
            set saldoe $A(saldob)
            dpg_select $tpl $MAIN(iddbs) "select a.un_nam, sum(a.summa) as summa \
                                            from oper a \
                                            where a.sot_cod = $A(sot_cod) and \
                                                  a.datvidano >= '01.$m.$y' and \
                                                  a.datvidano < '[GetFirstDayNextMonth $m $y]' and \
                                                  a.un_tip = 1 \
                                            group by a.un_nam \
                                            order by a.un_nam" N {
                lappend lstn [list [cnvs $N(un_nam)] $N(summa)]
            }
            dpg_select $tpl $MAIN(iddbs) "select a.un_nam, sum(a.summa) as summa \
                                            from oper a \
                                            where a.sot_cod = $A(sot_cod) and \
                                                  a.datvidano >= '01.$m.$y' and \
                                                  a.datvidano < '[GetFirstDayNextMonth $m $y]' and \
                                                  a.un_tip = -1 and \
                                                  a.un_vid in ('k','z') \
                                            group by a.un_nam \
                                            order by a.un_nam" U {
                lappend lstu [list [cnvs $U(un_nam)] $U(summa)]
            }
            dpg_select $tpl $MAIN(iddbs) "select a.un_nam, sum(a.summa) as summa \
                                            from oper a \
                                            where a.sot_cod = $A(sot_cod) and \
                                                  a.datvidano >= '01.$m.$y' and \
                                                  a.datvidano < '[GetFirstDayNextMonth $m $y]' and \
                                                  a.un_tip = -1 and \
                                                  a.un_vid = 'v' \
                                            group by a.un_nam \
                                            order by a.un_nam" V {
                lappend lstv [list [cnvs $V(un_nam)] $V(summa)]
            }
            set ln [llength $lstn]
            set lu [llength $lstu]
            set lv [llength $lstv]
            if { $ln > $lu }  { set big $ln } { set big $lu }
            if { $big < $lv } { set big $lv }
            for { set k 0 } { $k < $big } { incr k } {
                set namn [lindex [lindex $lstn $k] 0]
                set sumn [lindex [lindex $lstn $k] 1]
                set namu [lindex [lindex $lstu $k] 0]
                set sumu [lindex [lindex $lstu $k] 1]
                set namv [lindex [lindex $lstv $k] 0]
                set sumv [lindex [lindex $lstv $k] 1]
                
                set saldoe [expr $saldoe + [NullZero $sumn] \
                                         - [NullZero $sumu] \
                                         - [NullZero $sumv]]
                report output $tmonthyear [cnvs $A(pdr_nam)] $A(tn) [cnvs $A(fio)] \
                              $A(saldob) $namn $sumn $namu $sumu $namv $sumv $saldoe
            }
            ProgressIncr ${glv}(progress) [incr i] 3
            Unset lstn lstu lstv
        }
        PrintDoc $tpl "" [report stop]
        AfterQuery $glv
    }
}

proc Facerep:Execute { tpl } {
    global FACEREP
    set sot_cod {}
    Lindexes [Wreport:Get:YMPdr FACEREP] y m pdr_cod
    switch -exact -- $FACEREP(radio) {
        0 {
            set pdr_cod -1
            set pdr_nam {}
            set sot_cod -1
        }
        1 {
            set pdr_nam $FACEREP(head_pdr_nam)
        }
        2 {
            if { ![IsBe FACEREP(head_sot_fio)] || ![IsBe FACEREP(head_sot_cod)] ||
                 $FACEREP(head_sot_cod) <= 0 } {
                MessageDlg $tpl.dlg  -icon warning -type ok -message "  .   !"
                return
            }
            set pdr_cod -1
            set pdr_nam {}
            set sot_cod $FACEREP(head_sot_cod)
        }
    }
    Face:Report $tpl FACEREP $FACEREP(head_tmonth_year) $y $m $pdr_cod \
                $pdr_nam $sot_cod $FACEREP(head_sot_fio)
}
