proc Menu {} {
    global MAIN
    pack [label .f.l -image copyright -relief sunken -fg cyan4] -side left -fill y
    DynamicHelp::register .f.l balloon " \" \",  2.0 Copyright (c) 2001 Eduard E. Zozulya. doro@doro.poltava.ua "
    pack [Separator .f.sep1 -orient vertical] -side left -fill y -padx 2
    
    pack [menubutton .f.doc -menu .f.doc.m -text ""] -side left -fill y
    DynamicHelp::register .f.doc balloon "    "
    
    pack [menubutton .f.frm -menu .f.frm.m -text ""] -side left -fill y
    DynamicHelp::register .f.frm balloon "   "
    
    pack [menubutton .f.otc -menu .f.otc.m -text ""] -side left -fill y
    DynamicHelp::register .f.otc balloon "   "
    
    pack [menubutton .f.nsi -menu .f.nsi.m -text ""] -side left -fill y
    DynamicHelp::register .f.nsi balloon "   "
    
    pack [ComboBox .f.monthyear -editable 0 -width 13 -height 13 \
        -values [YearAmongMonth $MAIN(tmonthyear)] \
        -textvariable MAIN(tmonthyear) \
        -modifycmd "Menu:MonthYear .f.monthyear" \
        -helptext "      "] -side right -fill y
    pack [Separator .f.sep6 -orient vertical] -side right -fill y -padx 2
    pack [menubutton .f.ext -menu .f.ext.m -text ""] -side right -fill y
    DynamicHelp::register .f.ext balloon "    "

    menu .f.doc.m
        .f.doc.m add command -label "" -command Sot
        .f.doc.m add separator
        .f.doc.m add command -label "" -command Tabel
        .f.doc.m add command -label " ( -> )" -command "Naznach Sot Un"
        .f.doc.m add command -label " ( -> )" -command "Naznach Un Sot"
        .f.doc.m add command -label "" -command Vidano
        .f.doc.m add separator
        .f.doc.m add command -label ""
    menu .f.frm.m
        .f.frm.m add command -label " " -command Face
        .f.frm.m add separator
        .f.frm.m add command -label ""
    menu .f.otc.m
        .f.otc.m add command -label " " -command "Wreport Raschet"
        .f.otc.m add command -label " " -command "Wreport Facerep"
        .f.otc.m add separator
        .f.otc.m add command -label "     " -command "Wreport Svodun"
        .f.otc.m add command -label " " -command "Wreport Platve"
        .f.otc.m add command -label " " -command "Wreport Bankve"
        .f.otc.m add command -label " 8" -command "Wreport F8dr"
        .f.otc.m add separator
        .f.otc.m add command -label ""
    menu .f.nsi.m
        .f.nsi.m add command -label "  " -command Rn
        .f.nsi.m add separator
        .f.nsi.m add command -label "" -command "Un 1"
        .f.nsi.m add command -label "" -command "Un -1"
        .f.nsi.m add separator
        .f.nsi.m add command -label " " -command Strorg
        .f.nsi.m add separator
        .f.nsi.m add command -label "" -command Stat
        .f.nsi.m add separator
        .f.nsi.m add command -label ""
    menu .f.ext.m
        .f.ext.m add command -label " " -command exit
        .f.ext.m add separator
        .f.ext.m add command -label " "
}

proc Menu:MonthYear { w } {
    global MAIN
    $w configure -values [YearAmongMonth $MAIN(tmonthyear)]
    Lindexes $MAIN(tmonthyear) tm MAIN(year)
    set MAIN(month)       [GetMonthInt $tm]
    set MAIN(pmonth)      [clock format [clock scan "-1 month" -base [clock scan "$MAIN(year)-$MAIN(month)-01"]] -format %m]
    set MAIN(pyear)       [clock format [clock scan "-1 month" -base [clock scan "$MAIN(year)-$MAIN(month)-01"]] -format %Y]
    set MAIN(ptmonth)     [GetMonthText $MAIN(pmonth)]
    set MAIN(ptmonthyear) [format "%-8.8s %-4.4s" $MAIN(ptmonth) $MAIN(pyear)]
}
