proc Shablonunk:Create { win } {
    global SHABLONUNK_DATA SHABLONUNK
    set w $win.shablonunk
    if [winfo exists $w] { destroy $w }
    Unset SHABLONUBK_DATA
    toplevel $w
    wm transient $w $win
    wm withdraw $w
    wm title $w " "

    LoadWhileCreateWindow $w

    # MainFrame ####################################################################
    set mf [MainFrame $w.mf -textvariable SHABLONUNK(status) \
        -progressvar SHABLONUNK(progress) -progresstype infinite -progressmax 100]
    packef $mf
    $mf showstatusbar progression
    set tb [$mf addtoolbar]
    set mff [$mf getframe]
    
    # ToolBar ######################################################################
    pack [ButtonBox $tb.bb2 -spacing 0 ] -side right
    $tb.bb2 add -image quit -helptext "  <Esc> " -relief link -takefocus 0 \
        -highlightthickness 0 -command "Escape $w SHABLONUNK"

    pack [label $mff.l1 -text "   " \
        -font [option get $w bigFont Toplevel] \
        -fg black]

    pack [frame $mff.f]
    pack [scrollbar $mff.f.sby -command "$mff.f.tbl yview"] -side right -fill y
    pack [table $mff.f.tbl -width 2 -height 19 -cols 2 -rows 21 -relief flat \
        -yscrollcommand "$mff.f.sby set" \
        -browsecommand "Shablonunk:Tbl:Browsecommand %W" \
        -rowtagcommand { TkTableRowTagCmd } \
        -variable SHABLONUNK_DATA \
        -titlerows 1 \
        -roworigin -1 \
        -colorigin 0] -side left

    set SHABLONUNK(tblwindow) $mff.f.tbl
        
    TkTableInitTag  $mff.f.tbl
    TkTableInitBind $mff.f.tbl
    $mff.f.tbl width 0 30  1 9
    $mff.f.tbl tag col TitleCol2 0
    $mff.f.tbl tag col AnchorE 1
    
    bind $mff.f.tbl <KeyPress-Down> {}
    bind $mff.f.tbl <F8>            "Shablonunk:Del $win.shablonunk {}"
    bind $w         <Escape>        "$tb.bb2 invoke 0"
    
    BWidget::place $w 0 0 center
    wm deiconify $w
    Shablonunk:Sel $win.shablonunk
}

proc Shablonunk:Tbl:Browsecommand { w } {
    global SHABLONUNK SHABLONUNK_DATA SHABLONUNK_OLDDATA
    set active [$w index active]
    if ![IsBe SHABLONUNK(oldactive)] { set SHABLONUNK(oldactive) $active }
    scan [TkTableNotActiveDisabled $w $SHABLONUNK(oldactive) $active] \
         "%s%s%s%s%s%s" oldactive active oldrow row oldcol col
    
    set idxwrt [$w index $oldactive row]
    if { [$w index $active row] != $idxwrt } {
        Shablonunk:Write [winfo toplevel $w] $idxwrt 
    }
    
    if { [$w tag row Error] != $oldrow } {
        $w tag row [TkTableRowTagCmd $oldrow] $oldrow
    }
    $w tag row CurrentRow $row
    set SHABLONUNK(oldactive) $active
}
