proc SotI { bb chaild w } {
    global SOT SOTI SOTI_DATA
    Unset SOTI
    
    pack [frame $w.f -bd 1 -relief sunken] -anchor sw  -pady 2 -padx 3
    pack [scrollbar $w.f.sby -command "$w.f.tbl yview"] -side right -fill y
    pack [table $w.f.tbl -width 4 -height 12 -cols 4 -rows 12 -relief flat \
        -yscrollcommand "$w.f.sby set" \
        -browsecommand "SotI:Tbl:Browsecommand $w.f.tbl" \
        -rowtagcommand { TkTableRowTagCmd } \
        -variable SOTI_DATA \
        -titlerows 2 \
        -roworigin -2 \
        -colorigin 0] -side left

    TkTableInitTag $w.f.tbl
    $w.f.tbl width 0 27  1 11  2 11  3 3
    $w.f.tbl tag col AnchorE 1 2 3
    $w.f.tbl spans -2,0 1,0  -2,1 1,0  -2,2 1,0  -2,3 1,0
    TkTableInitBind $w.f.tbl
    bind $w <FocusIn>  "Sot:Activate:TF   $chaild"
    bind $w <FocusOut> "Sot:DeActivate:TF $chaild"
    bind $w.f.tbl <F8>       "SotI:Del $w.f.tbl"
    bind $w.f.tbl <KeyPress-Down> {}
    DynamicHelp::register $w.f.tbl balloon "    "
    set SOTI(tblwindow) $w.f.tbl
}

proc SotI:Tbl:Browsecommand { w } {
    global SOTI SOTI_DATA SOTI_OLDDATA MAIN
    set active [$w index active]
    if ![IsBe SOTI(oldactive)] { set SOTI(oldactive) $active }
    scan [TkTableNotActiveDisabled $w $SOTI(oldactive) $active] \
         "%s%s%s%s%s%s" oldactive active oldrow row oldcol col

    # after dol_nam
    if { $oldcol == 0 && [info exists SOTI_DATA($oldrow,0)] &&
         [info exists SOTI_DATA($oldrow,cod)] } {
        if { ![info exists SOTI_OLDDATA($oldrow,0)] ||
             $SOTI_DATA($oldrow,0) != $SOTI_OLDDATA($oldrow,0) } {
            set heret [He SOT $w -width 60 -find $SOTI_DATA($oldrow,0) -side top \
                         -anchor e -find $SOTI_DATA($oldrow,0) \
                         -title " " \
                         -deltay [expr 35 + 17 * $oldrow] \
                         -labels {  31 . 5  8  8 . 8 \
                                    31 " " 30 } \
                         -query "select a.nam as dol_nam, a.kolv, a.oklad, a.tarif, \
                                        a.kom, b.nam as pdr_nam, c.nam as rn_nam, \
                                        a.cod as dol_cod, b.cod as pdr_cod \
                                     from dol a, strorg b, rn c \
                                     where a.pdr_cod = b.cod and \
                                           a.rn_cod = c.cod and \
                                           a.kolv > 0 and \
                                           \[Construct a.nam \${wdd}HE(find)\] \
                                     order by a.nam"]
            
            set SOTI_DATA($oldrow,0)       [lindex $heret 0]
            set SOTI_DATA($oldrow,dol_cod) [lindex [lindex $heret 7] 0]
        }
    }
    
    set idxwrt [$w index $oldactive row]
    if { [$w index $active row] != $idxwrt } {
        SotI:Write $idxwrt $w
    }
    
    $w activate $active
    if { [$w tag row Error] != $oldrow } {
        $w tag row [TkTableRowTagCmd $oldrow] $oldrow
    }
    $w tag row CurrentRow $row
    set SOTI(oldactive) $active
}

