proc SotI:Init:SOTI_DATA {} {
    global SOTI_DATA SOTI_OLDDATA
    Unset SOTI_DATA SOTI_OLDDATA
    set idvr { -2,0   -2,1 " ."  \
               -2,2 " ." -2,3 " " }
    foreach { idx var } $idvr {
        set SOTI_DATA($idx) $var
    }
}

proc SotI:Sel { } {
    global SOTI_DATA SOTI SOT SOTI_OLDDATA MAIN
    SotI:Init:SOTI_DATA
    if [IsBe SOT(cod)] {
        set w $SOTI(tblwindow)
        BeforeQuery SOT "    ... "
        set i 0
        set query "select a.cod, a.dol_cod, b.nam, a.dt, a.du, a.kd \
                      from sotdol a, dol b \
                      where sot_cod = '$SOT(cod)' and \
                            a.dol_cod = b.cod \
                      order by a.dt"
        dpg_select .sot $MAIN(iddbs) $query A {
            set SOTI_DATA($i,cod)     $A(cod)
            set SOTI_DATA($i,dol_cod) $A(dol_cod)
            set SOTI_DATA($i,0)       [cnvs $A(nam)]
            set SOTI_DATA($i,1)       $A(dt)
            set SOTI_DATA($i,2)       $A(du)
            set SOTI_DATA($i,3)       $A(kd)
            ProgressIncr SOT(progress) [incr i] 2
        }
        array set SOTI_OLDDATA [array get SOTI_DATA]
        set titrows [$w cget -titlerows]
        if { $i > [expr [$w cget -rows] - $titrows] } {
            $w configure -rows [expr $i + $titrows]
        } else {
            $w configure -rows [$w cget -height]
        }
        TkTableRowTagErrorNull $w
        AfterQuery SOT
    }
}

proc SotI:Write { idx w } {
    global SOTI_DATA SOTI_OLDDATA
    if { [IsBe SOTI_DATA($idx,cod)] || [IsBe SOTI_DATA($idx,0)] || 
         [IsBe SOTI_DATA($idx,1)]   || [IsBe SOTI_DATA($idx,2)] } {
        if [IsBe SOTI_DATA($idx,cod)] {
            if { $SOTI_DATA($idx,dol_cod) != $SOTI_OLDDATA($idx,dol_cod) ||
                 $SOTI_DATA($idx,1) != $SOTI_OLDDATA($idx,1) ||
                 $SOTI_DATA($idx,2) != $SOTI_OLDDATA($idx,2) ||
                 $SOTI_DATA($idx,3) != $SOTI_OLDDATA($idx,3) } {
                SotI:Upd $idx $w
            }
        } else {
            if { [IsBe SOTI_DATA($idx,dol_cod)] && [IsBe SOTI_DATA($idx,1)] &&
                 [IsBe SOTI_DATA($idx,2)] && [IsBe SOTI_DATA($idx,3)] } {
                #SotI:Ins $idx $w
            }
        }
    }
}

proc SotI:Upd { idx w } {
    global SOTI_DATA MAIN SOTI_OLDDATA SOT
    BeforeQuery SOT "   $idx ... "
    set query "select sotdol_upd('$SOTI_DATA($idx,cod)', \
                                 '$SOTI_DATA($idx,dol_cod)', \
                                 '$SOTI_DATA($idx,1)', \
                                 '$SOTI_DATA($idx,2)', \
                                 '$SOTI_DATA($idx,3)')"
    set err [dpg_select .sot $MAIN(iddbs) $query A {
        incr SOT(progress)
    }]
    if { $err == -1 } {
        $w tag row Error $idx
    } else {
        foreach i { 0 1 2 3 } {
            set SOTI_OLDDATA($idx,$i) $SOTI_DATA($idx,$i)
        }
        $w tag row [TkTableRowTagCmd $idx] $idx
    }
    AfterQuery SOT
}

proc SotI:Del { w } {
    global SOTI_DATA MAIN SOTI_OLDDATA SOT
    set row [$w index active row]
    if [IsBe SOTI_DATA($row,cod)] {
        if ![MessageDlg .sot.dlg -buttons { } -icon question -type user -message "  $row ?" -default 0] {
            BeforeQuery SOT "   $row ... "
            set query "select sotdol_del('$SOTI_DATA($row,cod)')"
            set err [dpg_select .sot $MAIN(iddbs) $query A {
                incr SOT(progress)
            }]
            if { $err == -1 } {
                $w tag row Error $row
            } else {
                $w tag row CurrentRow $row
                SotI:Sel
            }
            AfterQuery SOT
        }
    }
}
