proc SotT { bb chaild w } {
    global SOTT
    Unset SOTT
    
    pack [frame $w.f1 -bd 0] -anchor w
    pack [LabelEntry $w.f1.dol -helptext "   " \
            -label "             " \
            -textvariable SOTT(dol_nam) -width 28 \
            -command "SotT:He $w.f1.dol" ] -side left
    $w.f1.dol bind <Return> { focus [Widget::focusNext %W] }
    pack [ArrowButton $w.f1.ab -dir bottom -command "SotT:He $w.f1.dol" \
        -helptext "     " ] -side right -fill y

    pack [LabelEntry $w.dt -helptext "    " \
            -label "   " \
            -textvariable SOTT(dt) -width 10] -anchor w
    $w.dt bind <Return> { focus [Widget::focusNext %W] }
    $w.dt bind <FocusIn> { if ![IsBe SOTT(dt)] { set SOTT(dt) $MAIN(today) } }
    
    pack [LabelEntry $w.kd -helptext "    (01) - , (02) -  " \
            -label "             " \
            -textvariable SOTT(kd) -width 2] -anchor w
    $w.kd bind <Return>   "SotT:Ins $w"
    $w.kd bind <KP_Enter> "SotT:Ins $w"
    $w.kd bind <FocusIn> { if ![IsBe SOTT(kd)] { set SOTT(kd) "01" } }
    bind $w    <FocusIn>  "Sot:Activate:TF   $chaild"
    bind $w    <FocusOut> "Sot:DeActivate:TF $chaild"    

    #################################################################################

    pack [frame $w.f2] -anchor e
    foreach { i j k } { du      "   " 10
                        pdr_nam "    " 28
                        rn_nam  "    " 28
                        oklad   "            " 8 } {
        pack [LabelEntry $w.f2.$i -label $j -textvariable SOTT($i) -width $k \
                -editable 0 -takefocus 0 -bg grey70] -anchor w
    }
    pack [frame $w.f2.f1 -bd 0] -anchor w -fill x
    pack [frame $w.f2.f1.frb -bd 2 -relief groove] -side right -anchor s
    pack [button $w.f2.f1.frb.ins -text  -takefocus 0 -command "SotT:Ins $w" \
                 -state disabled] -padx 2 -pady 2
    DynamicHelp::register $w.f2.f1.frb.ins balloon "   "
    foreach { i j k } { tarif   "            " 8
                        kom     "     " 6 } {
        pack [LabelEntry $w.f2.f1.$i -label $j -textvariable SOTT($i) -width $k \
                -editable 0 -takefocus 0 -bg grey70] -anchor w
    }

    #################################################################################
    
    pack [frame $w.f3 -bd 2 -relief groove] -pady 5
    pack [ArrowButton $w.f3.ab1 -dir left -helptext "    " \
            -command "SotT:NextPrev - 1" -width 15 -height 25] -side left -pady 2 -padx 2
    pack [scale $w.f3.sc -length 200 -orient hor -width 7 \
            -command "SotT:NextPrev =" -variable SOTT(varscale)] -side left
    DynamicHelp::register $w.f3.sc balloon "      "
    set SOTT(window_scale) $w.f3.sc
    pack [ArrowButton $w.f3.ab2 -dir right -helptext "    " \
            -command "SotT:NextPrev + 1" -width 15 -height 25] -side right -pady 2 -padx 2
}

proc SotT:NextPrev { zn cn } {
    global SOTT SOTT_DATA SOT
    if { $zn == "=" } {
        set idx [expr $cn - 1]
    } else {
        set idx [expr $SOTT(varscale) $zn $cn - 1]
        set SOTT(varscale) [expr $idx + 1]
    }
    set idx [expr int($idx)]
    if { $idx < 0 } { set idx 0 }
    if { $idx >= 0 } {
        if [IsBe SOTT_DATA(cod)] {
            foreach i { cod dol_nam dt kd du pdr_nam rn_nam oklad tarif kom } {
                set SOTT($i) [lindex $SOTT_DATA($i) $idx]
            }
        }
    }
    
    if [IsBe SOTT(dol_nam)] {
        SotT:Editable 0 $SOT(frame_SotT)
    } else {
        SotT:Editable 1 $SOT(frame_SotT)
    }
    
    if { $idx >= [$SOTT(window_scale) cget -to] } {
        set newto [expr [$SOTT(window_scale) cget -to] + 1]
        $SOTT(window_scale) configure -to $newto
        set SOTT(varscale) $newto
    }
}

proc SotT:He { w } {
    global SOTT
    set heret [He SOT $w -width 60 -find $SOTT(dol_nam) -side top -anchor e \
                         -title " " -deltax 15 \
                         -labels {  31 . 5  8  8 . 8  31 " " 30} \
                         -query "select a.nam as dol_nam, a.kolv, a.oklad, a.tarif, \
                                        a.kom, b.nam as pdr_nam, c.nam as rn_nam, \
                                        a.cod as dol_cod, b.cod as pdr_cod \
                                     from dol a, strorg b, rn c \
                                     where a.pdr_cod = b.cod and \
                                           a.rn_cod = c.cod and \
                                           a.kolv > 0 and \
                                           \[Construct a.nam \${wdd}HE(find)\] \
                                     order by a.nam"]
    set SOTT(dol_nam) [lindex $heret 0]
    set SOTT(oklad)   [lindex $heret 2]
    set SOTT(tarif)   [lindex $heret 3]
    set SOTT(kom)     [lindex $heret 4]
    set SOTT(pdr_nam) [lindex $heret 5]
    set SOTT(rn_nam)  [lindex $heret 6]
    set SOTT(dol_cod) [lindex [lindex $heret 7] 0]
    set SOTT(pdr_cod) [lindex [lindex $heret 7] 1]
}

proc SotT:Editable { flg w } {
    global SOTT
    if [winfo exists $w] {
        set ad disabled
        if $flg { set ad normal }
        foreach i { f1.dol dt kd } {
            $w.$i configure -editable $flg
        }
        $w.f1.ab configure -state $ad
        $w.f2.f1.frb.ins configure -state $ad
        if $flg {
            set SOTT(flgbutton) 1
        } else {
            Unset SOTT(flgbutton)
        }
    }
}
