proc SotU { bb chaild w } {
    global SOTU MAIN
    Unset SOTU
    
    pack [frame $w.f2] -anchor e
    foreach { i j k } { dol_nam "    " 28
                        dt      "       " 10 } {
        pack [LabelEntry $w.f2.$i -label $j -textvariable SOTU($i) -width $k \
                -editable 0 -takefocus 0 -bg grey70] -anchor w
    }
    pack [frame $w.f2.f1 -bd 0] -anchor w -fill x
    pack [frame $w.f2.f1.frb -bd 2 -relief groove] -side right -anchor s
    
    pack [button $w.f2.f1.frb.ins -text  -takefocus 0 -command "SotU:Ins $w" \
                 -state disabled] -padx 2 -pady 2
    DynamicHelp::register $w.f2.f1.frb.ins balloon "   "
    
    pack [LabelEntry $w.f2.f1.kd -textvariable SOTU(kd) -width 2 \
                        -label  "                 " \
                -editable 0 -takefocus 0 -bg grey70] -anchor w
    pack [LabelEntry $w.f2.f1.du -textvariable SOTU(du) -width 10 \
                        -label  "            " ] -anchor w -pady 1

    $w.f2.f1.du bind <Return>   "SotU:Ins $w"
    $w.f2.f1.du bind <KP_Enter> "SotU:Ins $w"
    $w.f2.f1.du bind <FocusIn>  { if ![IsBe SOTU(du)] { set SOTU(du) $MAIN(today) } }
    bind $w    <FocusIn>  "Sot:Activate:TF   $chaild"
    bind $w    <FocusOut> "Sot:DeActivate:TF $chaild"

    #################################################################################
    
    pack [frame $w.f3 -bd 2 -relief groove] -pady 5
    pack [ArrowButton $w.f3.ab1 -dir left -helptext "    " \
            -command "SotU:NextPrev - 1" -width 15 -height 25] -side left -pady 2 -padx 2
    pack [scale $w.f3.sc -length 200 -orient hor -width 7 \
            -command "SotU:NextPrev =" -variable SOTU(varscale)] -side left
    DynamicHelp::register $w.f3.sc balloon "      "
    set SOTU(window_scale) $w.f3.sc
    pack [ArrowButton $w.f3.ab2 -dir right -helptext "    " \
            -command "SotU:NextPrev + 1" -width 15 -height 25] -side right -pady 2 -padx 2
}

proc SotU:NextPrev { zn cn } {
    global SOTU SOTU_DATA SOT
    if { $zn == "=" } {
        set idx [expr $cn - 1]
    } else {
        set idx [expr $SOTU(varscale) $zn $cn - 1]
        set SOTU(varscale) [expr $idx + 1]
    }
    if { $idx >= 0 && $idx < [$SOTU(window_scale) cget -to] } {
        if [IsBe SOTU_DATA(cod)] {
            foreach i { cod dol_nam dt kd } {
                set SOTU($i) [lindex $SOTU_DATA($i) $idx]
            }
        }
    }
}

proc SotU:Editable { flg w } {
    global SOTU
    if [winfo exists $w] {
        set ad disabled
        if $flg { set ad normal }
        $w.f2.f1.du configure -editable $flg
        $w.f2.f1.frb.ins configure -state $ad
        if $flg {
            set SOTU(flgbutton) 1
        } else {
            Unset SOTU(flgbutton)
        }
    }
}
