proc SotU:ClearVar {} {
    global SOTU
    foreach i { cod dol_nam dt kd du } {
        set SOTU($i) ""
    }
}

proc SotU:Sel {} {
    global SOTU MAIN SOT SOTU_DATA
    set w $SOT(frame_SotU)
    set cnt 1
    $SOTU(window_scale) configure -from 1
    if [IsBe SOT(cod)] {
        BeforeQuery SOT "     ... "
        SotU:ClearVar
        Unset SOTU_DATA
        SotU:Editable 1 $w
        set query "select a.cod, d.nam as dol_nam, a.dt, a.kd \
                    from sotdol a, dol d \
                    where a.dol_cod = d.cod and \
                          a.sot_cod = '$SOT(cod)' and \
                          a.dt < '$MAIN(firstdaynextmonth)' and \
                          a.du is null \
                    order by a.dt, a.kd"
        dpg_select .sot $MAIN(iddbs) $query A {
            foreach i { cod dol_nam dt kd } {
                lappend SOTU_DATA($i) [cnvs $A($i)]
            }
            incr SOT(progress)
            if { $cnt == 1 } { 
                foreach i { cod dol_nam dt kd } {
                    set SOTU($i) [cnvs $A($i)]
                }
            }
            incr cnt
        }
        if { $cnt == 1 } {
            $SOTU(window_scale) configure -from 0
        }
        $SOTU(window_scale) configure -to [expr $cnt - 1]
        AfterQuery SOT
    }
    if ![IsBe SOTU(dol_nam)] {
        SotU:Editable 0 $w
    } else {
        SotU:Editable 1 $w
    }
}

proc SotU:Ins { w } {
    global SOTU MAIN SOT
    if { [IsBe SOTU(du)] && [IsBe SOTU(cod)] } {
        if ![MessageDlg .sot.dlg -buttons { } -icon question -type user \
                -message " ?\n\"$SOT(fio)\"" -default 0] {
            BeforeQuery SOT "   ... "
            set query "select sotdolu_ins('$SOTU(cod)', '$SOTU(du)') as cod"
            dpg_select .sot $MAIN(iddbs) $query A {
                SotU:Sel
                focus -force $SOT(mclwindow)
            }
            AfterQuery SOT
        }
    }
}
