proc SotUnk:Tbl { w wdd } {
    global ${wdd}SOTUNK ${wdd}SOTUNK_DATA

    pack [frame $w.f] -side right -fill y
    pack [TitleFrame $w.f.tf2 -text "   "] \
        -side top -anchor n
    set tf2 [$w.f.tf2 getframe]
    pack [frame $tf2.f -bd 1 -relief sunken] -anchor sw  -pady 2 -padx 3
    pack [scrollbar $tf2.f.sby -command "$tf2.f.tbl yview"] -side right -fill y
    pack [table $tf2.f.tbl -width 2 -height 19 -cols 2 -rows 19 -relief flat \
        -yscrollcommand "$tf2.f.sby set" \
        -browsecommand "SotUnk:Tbl:Browsecommand %W $wdd" \
        -rowtagcommand { TkTableRowTagCmd } \
        -variable ${wdd}SOTUNK_DATA \
        -titlerows 1 \
        -roworigin -1 \
        -colorigin 0] -side left
        
    TkTableInitTag $tf2.f.tbl
    TkTableInitBind $tf2.f.tbl
    $tf2.f.tbl width 0 30  1 8
    $tf2.f.tbl tag col TitleCol2 0
    $tf2.f.tbl tag col AnchorE 1
    
    bind $tf2.f.tbl <KeyPress-Down> {}
    bind $tf2.f.tbl <F8>            "SotUnk:Del $wdd {}"
    bind $tf2.f.tbl <FocusIn>       "Naznach:Activate:TF   $w.f.tf2"
    bind $tf2.f.tbl <FocusOut>      "Naznach:DeActivate:TF $w.f.tf2"
    set ${wdd}SOTUNK(tblwindow) $tf2.f.tbl
}

proc SotUnk:Tbl:Browsecommand { w wdd } {
    global ${wdd}SOTUNK
    set active [$w index active]
    if ![IsBe ${wdd}SOTUNK(oldactive)] { set ${wdd}SOTUNK(oldactive) $active }
    scan [TkTableNotActiveDisabled $w [subst $${wdd}SOTUNK(oldactive)] $active] \
         "%s%s%s%s%s%s" oldactive active oldrow row oldcol col
    
    set idxwrt [$w index $oldactive row]
    if { [$w index $active row] != $idxwrt } {
        SotUnk:Write $wdd $idxwrt 
    }
    
    if { [$w tag row Error] != $oldrow } {
        $w tag row [TkTableRowTagCmd $oldrow] $oldrow
    }
    $w tag row CurrentRow $row
    set ${wdd}SOTUNK(oldactive) $active
}
