proc Svodun:Execute { tpl } {
    global SVODUN
    Lindexes [Wreport:Get:YMPdr SVODUN] y m pdr_cod
    Svodun:Report $tpl SVODUN $SVODUN(head_tmonth_year) $y $m
}


proc Svodun:Report { tpl glv tmonthyear y m } {
    global MAIN $glv
    
    if ![MessageDlg $tpl.dlg -buttons { } -icon question -type user -message "  ?" -default 0] {
        BeforeQuery $glv "   ... "
        report start svodnpdr
        set i 0
        dpg_select $tpl $MAIN(iddbs) \
            "select b.nam as pdr_nam, c.nam as un_nam, sum(a.summa) as summa
                from oper a, strorg b, un c
                where a.datvidano = '01.$m.$y' and
                      a.pdr_cod = b.cod and
                      a.un_cod = c.cod and
                      c.tip = 1
                group by b.nam, c.nam
                order by b.nam, c.nam
            " A {
            report output $tmonthyear [cnvs $A(pdr_nam)] [cnvs $A(un_nam)] $A(summa)
            ProgressIncr ${glv}(progress) [incr i] 2
        }
        set lst [report stop]
        
        report start svodnorg
        dpg_select $tpl $MAIN(iddbs) \
            "select c.nam as un_nam, sum(a.summa) as summa
                from oper a, un c
                where a.datvidano = '01.$m.$y' and
                      a.un_cod = c.cod and
                      c.tip = 1
                group by c.nam
                order by c.nam
            " A {
            report output [cnvs $A(un_nam)] $A(summa)
            ProgressIncr ${glv}(progress) [incr i] 2
        }
        append lst " [report stop]"
        
        report start svoduorg
        dpg_select $tpl $MAIN(iddbs) \
            "select c.nam as un_nam, sum(a.summa) as summa
                from oper a, un c
                where a.datvidano = '01.$m.$y' and
                      a.un_cod = c.cod and
                      c.tip = -1
                group by c.nam
                order by c.nam
            " A {
            report output $tmonthyear [cnvs $A(un_nam)] $A(summa)
            ProgressIncr ${glv}(progress) [incr i] 2
        }
        PrintDoc $tpl "   " "$lst [report stop]"
        AfterQuery $glv
    }
}

