proc Unr:Init:UNR_DATA { wdd vid } {
    global ${wdd}UNR_DATA ${wdd}UNR_OLDDATA ${wdd}UNR
    Unset ${wdd}UNR_DATA ${wdd}UNR_OLDDATA
    if [VarIn vid t n z k b v] {
        set idvr { -2,0  -2,2 " " -2,3  -1,0  -1,1  }
        foreach { idx var } $idvr {
            set ${wdd}UNR_DATA($idx) $var
        }
    }
    #         (    )
    if [VarIn vid s] {
        set idvr { -2,0 " ( )" -1,2 . -2,3  -1,0 . -1,1 . }
        foreach { idx var } $idvr {
            set ${wdd}UNR_DATA($idx) $var
        }
    }
    if [VarIn vid p] {
        set idvr { -2,0 "-  " -2,2 " " -2,3  -1,0  -1,1  }
        foreach { idx var } $idvr {
            set ${wdd}UNR_DATA($idx) $var
        }
    }
}

proc Unr:Sel { wddun wdd vid } {
    global ${wdd}UNR_DATA UN ${wddun}UN ${wdd}UNR MAIN ${wdd}UNR_OLDDATA
    Unr:Init:UNR_DATA $wdd $vid
    set w [subst $${wdd}UNR(tblwindow)]
    BeforeQuery UN "  , ,  ... "
    set i 0
    set query "select cod, c1, c2, c3, c4 from unr \
                where un_cod = '[subst $${wddun}UN(cod)]' \
                order by c1, c2, c3, c4"
    dpg_select .un $MAIN(iddbs) $query A {
        set ${wdd}UNR_DATA($i,cod) $A(cod)
        set ${wdd}UNR_DATA($i,0)   $A(c1)
        set ${wdd}UNR_DATA($i,1)   $A(c2)
        set ${wdd}UNR_DATA($i,2)   $A(c3)
        set ${wdd}UNR_DATA($i,3)   $A(c4)
        ProgressIncr UN(progress) [incr i] 2
    }
    array set ${wdd}UNR_OLDDATA [array get ${wdd}UNR_DATA]
    set titrows [$w cget -titlerows]
    if { $i > [expr [$w cget -rows] - $titrows] } {
        $w configure -rows [expr $i + $titrows]
    } else {
        $w configure -rows [$w cget -height]
    }
    TkTableRowTagErrorNull $w
    AfterQuery UN
}

proc Unr:Write { idx wddun w wdd vid } {
    global ${wdd}UNR_DATA ${wdd}UNR_OLDDATA UN
    if [IsBe ${wdd}UNR_DATA($idx,cod)] {
        if { ( [subst $${wdd}UNR_DATA($idx,0)] != [subst $${wdd}UNR_OLDDATA($idx,0)] ||
               [subst $${wdd}UNR_DATA($idx,1)] != [subst $${wdd}UNR_OLDDATA($idx,1)] ||
               [subst $${wdd}UNR_DATA($idx,2)] != [subst $${wdd}UNR_OLDDATA($idx,2)] ||
               [subst $${wdd}UNR_DATA($idx,3)] != [subst $${wdd}UNR_OLDDATA($idx,3)] ) && 
               [IsBe ${wdd}UNR_DATA($idx,0)] && [IsBe ${wdd}UNR_DATA($idx,1)] &&
               [IsBe ${wdd}UNR_DATA($idx,2)] && [IsBe ${wdd}UNR_DATA($idx,3)] } { 
            Unr:Upd $wddun $w $wdd $vid $idx
        } elseif { [IsBe ${wdd}UNR_OLDDATA($idx,0)] && [IsBe ${wdd}UNR_OLDDATA($idx,1)] &&
                   [IsBe ${wdd}UNR_OLDDATA($idx,2)] && [IsBe ${wdd}UNR_OLDDATA($idx,3)] &&
                   ![IsBe ${wdd}UNR_DATA($idx,0)] && ![IsBe ${wdd}UNR_DATA($idx,1)] &&
                   ![IsBe ${wdd}UNR_DATA($idx,2)] && ![IsBe ${wdd}UNR_DATA($idx,3)] } { 
            Unr:Del $wddun $w $wdd $vid $idx
        }
    } else {
        if { [IsBe ${wdd}UNR_DATA($idx,0)] && [IsBe ${wdd}UNR_DATA($idx,1)] && \
             [IsBe ${wdd}UNR_DATA($idx,2)] && [IsBe ${wdd}UNR_DATA($idx,3)] } {
            Unr:Ins $wddun $w $wdd $vid $idx
        }
    }
}

proc Unr:Ins { wddun w wdd vid idx } {
    global ${wddun}UN ${wdd}UNR_DATA MAIN ${wdd}UNR_OLDDATA UN
    BeforeQuery UN "   $idx ... "
    set query "select unr_ins('[subst $${wddun}UN(cod)]', \
                      '[subst $${wdd}UNR_DATA($idx,0)]', \
                      '[subst $${wdd}UNR_DATA($idx,1)]', \
                      '[subst $${wdd}UNR_DATA($idx,2)]', \
                      '[subst $${wdd}UNR_DATA($idx,3)]') as cod"
    set err [dpg_select .un $MAIN(iddbs) $query A {
        set ${wdd}UNR_DATA($idx,cod) $A(cod)
        incr UN(progress)
    }]
    if { $err == -1 } {
        $w tag row Error $idx
    } else {
        foreach i { cod 0 1 2 3 } {
            set ${wdd}UNR_OLDDATA($idx,$i) [subst $${wdd}UNR_DATA($idx,$i)]
        }
        $w tag row [TkTableRowTagCmd $idx] $idx
    }
    AfterQuery UN
}

proc Unr:Upd { wddun w wdd vid idx } {
    global ${wdd}UNR_DATA MAIN ${wdd}UNR_OLDDATA UN
    BeforeQuery UN "   $idx ... "
    set query "select unr_upd('[subst $${wdd}UNR_DATA($idx,cod)]', \
                              '[subst $${wdd}UNR_DATA($idx,0)]', \
                              '[subst $${wdd}UNR_DATA($idx,1)]', \
                              '[subst $${wdd}UNR_DATA($idx,2)]', \
                              '[subst $${wdd}UNR_DATA($idx,3)]')"
    set err [dpg_select .un $MAIN(iddbs) $query A {
        incr UN(progress)
    }]
    if { $err == -1 } {
        $w tag row Error $idx
    } else {
        foreach i { 0 1 2 3 } {
            set ${wdd}UNR_OLDDATA($idx,$i) [subst $${wdd}UNR_DATA($idx,$i)]
        }
        $w tag row [TkTableRowTagCmd $idx] $idx
    }
    AfterQuery UN
}

proc Unr:Del { wddun w wdd vid row } {
    global ${wdd}UNR_DATA MAIN ${wdd}UNR_OLDDATA UN
    if ![IsBe row] { set row [$w index active row] }
    if [IsBe ${wdd}UNR_DATA($row,cod)] {
        if ![MessageDlg .un.dlg -buttons { } -icon question -type user -message "  $row ?" -default 0] {
            BeforeQuery UN "   $row ... "
            set query "select unr_del('[subst $${wdd}UNR_DATA($row,cod)]')"
            set err [dpg_select .un $MAIN(iddbs) $query A {
                incr UN(progress)
            }]
            if { $err == -1 } {
                $w tag row Error $row
            } else {
                $w tag row CurrentRow $row
                Unr:Sel $wddun $wdd $vid
            }
            AfterQuery UN
        }
    }
}
