proc Unz:Init:UNZ_DATA { wdd vid } {
    global ${wdd}UNZ_DATA ${wdd}UNZ
    Unset ${wdd}UNZ_DATA
    set idvr { -2,0 " /" -2,1 "+  - " }
    foreach { idx var } $idvr {
        set ${wdd}UNZ_DATA($idx) $var
    }
    eval destroy [ChildrenWindow [subst $${wdd}UNZ(tblwindow)]]
}

proc Unz:Sel { wddun wdd vid } {
    global ${wdd}UNZ_DATA UN ${wddun}UN ${wdd}UNZ MAIN
    Unz:Init:UNZ_DATA $wdd $vid
    set w [subst $${wdd}UNZ(tblwindow)]
    set titrows [$w cget -titlerows]
    BeforeQuery UN "   / ... "
    set i 0
    if [IsBe ${wddun}UN(cod)] {
        set color1 [option get $w rowOne Table]
        set color2 [option get $w rowTwo Table]
        set query "select a.nam, a.cod, a.tip, a.vid, b.s_cod, b.s_cod/b.s_cod as sort \
                    from un a left outer join unz as b on \
                                   a.cod = b.s_cod and \
                                   b.m_cod = '[subst $${wddun}UN(cod)]'
                    where a.cod != '[subst $${wddun}UN(cod)]'
                    order by sort, a.tip desc, a.nam"
        
        dpg_select .un $MAIN(iddbs) $query A {
            set ${wdd}UNZ_DATA($i,cod)   $A(cod)
            set ${wdd}UNZ_DATA($i,tip)   $A(tip)
            set ${wdd}UNZ_DATA($i,vid)   $A(vid)
            set ${wdd}UNZ_DATA($i,s_cod) $A(s_cod)
            set ${wdd}UNZ_DATA($i,0)     [cnvs $A(nam)]
            $w configure -rows [expr $i + $titrows + 1]
            catch [destroy $w.b$i]
            label $w.b$i -image [Unz:ImgPlusMinus $A(s_cod) $A(tip)] -bd 0 \
                       -bg [Unz:Tbl:RowColor $color1 $color2 $i]
            bind $w.b$i <1> "Unz:Tbl:Bind:Lbl $wddun $wdd $w $i $vid"
            $w window configure $i,1 -window $w.b$i -sticky wens
            ProgressIncr UN(progress) [incr i] 5
        }
    }        
        
    if { $i > [expr [$w cget -rows] - $titrows] } {
        $w configure -rows [expr $i + $titrows]
    } else {
        $w configure -rows [expr $i + $titrows]
    }
    AfterQuery UN
}

proc Unz:Tbl:RowColor { color1 color2 row } {
    if { [expr $row % 2] == 0 } {
        return $color1
    }
    return $color2
}

proc Unz:Tbl:Bind:Lbl { wddun wdd w row vid } {
    global ${wdd}UNZ_DATA
    if ![IsBe ${wdd}UNZ(WaitReturn)] {
        set ${wdd}UNZ(WaitReturn) 1
        set oldrow [$w tag row CurrentRow]
        $w tag row CurrentRow $row
        $w.b$row configure -bg [option get $w currentBackground Table]
        $w activate $row,1
        if [IsBe oldrow] {
            if { $oldrow != $row } {
                $w tag row [TkTableRowTagCmd $oldrow] $oldrow
                $w.b$oldrow configure -bg [option get $w [TkTableRowTagCmd $oldrow] Table]
            }
        }
        if [IsBe ${wdd}UNZ_DATA($row,s_cod)] {
            Unz:Del $wddun $wdd $w $row $vid
        } else {
            Unz:Ins $wddun $wdd $w $row $vid
        }
        set ${wdd}UNZ(WaitReturn) {}
    }
}

proc Unz:Ins { wddun wdd w row vid } {
    global ${wddun}UN ${wdd}UNZ_DATA MAIN UN
    BeforeQuery UN "    [subst $${wdd}UNZ_DATA($row,0)] ... "
    set query "select unz_ins('[subst $${wddun}UN(cod)]','$UN(tip)','$vid',\
                              '[subst $${wdd}UNZ_DATA($row,cod)]',
                              '[subst $${wdd}UNZ_DATA($row,tip)]',
                              '[subst $${wdd}UNZ_DATA($row,vid)]') as cod"
    
    set err [dpg_select .un $MAIN(iddbs) $query A {
        set ${wdd}UNZ_DATA($row,s_cod) [subst $${wdd}UNZ_DATA($row,cod)]
        incr UN(progress)
    }]
    
    if { $err == -1 } {
        $w tag row Error $row
    } else {
        $w.b$row configure -image [Unz:ImgPlusMinus 1 [subst $${wdd}UNZ_DATA($row,tip)]]
        $w tag row CurrentRow $row
    }
    AfterQuery UN
}

proc Unz:Del { wddun wdd w row vid } {
    global ${wddun}UN ${wdd}UNZ_DATA MAIN UN
    BeforeQuery UN "    [subst $${wdd}UNZ_DATA($row,0)] ... "
    set query "select unz_del('[subst $${wddun}UN(cod)]','$UN(tip)','$vid',\
                              '[subst $${wdd}UNZ_DATA($row,cod)]',
                              '[subst $${wdd}UNZ_DATA($row,tip)]',
                              '[subst $${wdd}UNZ_DATA($row,vid)]') as cod"
    
    set err [dpg_select .un $MAIN(iddbs) $query A {
        set ${wdd}UNZ_DATA($row,s_cod) {}
        incr UN(progress)
    }]
    
    if { $err == -1 } {
        $w tag row Error $row
    } else {
        $w.b$row configure -image [Unz:ImgPlusMinus 0 [subst $${wdd}UNZ_DATA($row,tip)]]
        $w tag row CurrentRow $row
    }
    AfterQuery UN
}

proc Unz:ImgPlusMinus { cod tip } {
    set img minus
    set clr R
    if { $cod > 0 }  { set img plus }
    if { $tip == 1 } { set clr G }
    return $img$clr
}
