proc Wreport { Rep } { 
    set REP [string toupper $Rep] 
    set rep [string tolower $Rep] 
    global MAIN $REP 
    Unset $REP 
    set tpl .$rep 
    if [winfo exists $tpl] { destroy $tpl } 
    toplevel $tpl 
    wm withdraw $tpl 
    wm title $tpl [Case Rep Raschet Facerep Svodun Platve Bankve F8dr      8] 
    set txt1      [Case Rep Raschet Facerep Svodun Platve Bankve F8dr " " " " "   " " " " " " 8"] 
    set txt2      [Case Rep Raschet Facerep Svodun Platve Bankve F8dr " " " " " " " " " " " "]

    LoadWhileCreateWindow $tpl

    # MainFrame ####################################################################
    set mf [MainFrame $tpl.mf -textvariable ${REP}(status) \
            -progressvar ${REP}(progress) -progresstype infinite -progressmax 100]
    packef $mf
    $mf showstatusbar progression
    set tb [$mf addtoolbar]
    set mff [$mf getframe]
    
    # ToolBar ######################################################################
    pack [Separator $tb.sep1 -orient vertical] -side left -fill y -padx 2
    pack [ButtonBox $tb.bb2 -spacing 0 ] -side right
    foreach { i j k } [list quit "  <Esc> " "Escape $tpl $REP"] {
        $tb.bb2 add -image $i -helptext $j -relief link -takefocus 0 \
            -highlightthickness 0 -command $k
    }
    
    # Head #########################################################################
    pack [frame $mff.head]
    
    Pdr:Sel $REP
    set ${REP}(head_tmonth_year) $MAIN(tmonthyear)
        
    pack [set hf1 [frame $mff.head.f1]]
    pack [set hf2 [frame $mff.head.f2 -bd 2 -relief groove]]
    pack [label $hf1.l1 -text $txt1 -font [option get $hf1 bigFont Frame] \
        -fg black] -side left
     if ![VarIn Rep F8dr] {
        if [VarIn Rep Platve Bankve] {
            pack [ComboBox $hf1.day -editable 0 -label "  " -width 2 \
                -textvariable ${REP}(head_day) \
                -helptext "   "] -side left
            set ${REP}(daywindow) $hf1.day
        }
        pack [ComboBox $hf1.monthyear -editable 0  -width 13 -height 13 \
            -values [YearAmongMonth [subst $${REP}(head_tmonth_year)]] \
            -modifycmd "Wreport:Dat $REP" \
            -textvariable ${REP}(head_tmonth_year) \
            -helptext "   "] -side left
        set ${REP}(monthyearwindow) $hf1.monthyear
        
        if [VarIn Rep Raschet Facerep Platve Bankve] {
            set ${REP}(radio) 0
            pack [radiobutton $hf2.rb1 -text " " \
                -command "Wreport:AcDeactivate $hf2.rb1 {} $REP" \
                -value 0 -variable ${REP}(radio)] -anchor w -padx 2
            
            pack [set hf3 [frame $hf2.f3]] -anchor w -padx 2
            pack [radiobutton $hf3.rb1 -text " " \
                -command "Wreport:AcDeactivate $hf3.rb1 $hf3.pdr $REP"\
                -value 1 -variable ${REP}(radio)] -side left
            pack [ComboBox $hf3.pdr -editable 0 -width 30 \
                -values [subst $${REP}(lpdr_nam)]  -modifycmd "Wreport:Pdr $REP" \
                -textvariable ${REP}(head_pdr_nam) \
                -helptext "   "] -side left
            set ${REP}(pdrwindow)       $hf3.pdr
                
            if [VarIn Rep Raschet Facerep] {
                pack [set hf4 [frame $hf2.f4]] -anchor w -padx 2
                pack [radiobutton $hf4.rb1 -text "    " \
                    -command "Wreport:AcDeactivate $hf4.rb1 $hf4.sot $REP" \
                    -value 2 -variable ${REP}(radio)] -side left
                pack [Entry $hf4.sot -width 50 \
                    -command "Wreport:HeSot $tpl $REP" \
                    -textvariable ${REP}(head_sot_fio) \
                    -helptext "    "] -side left
                set ${REP}(sotwindow)       $hf4.sot
            }
        }
    } else {
        set ${REP}(head_kvartal) [expr $MAIN(month) / 4 + 1]
        pack [ComboBox $hf1.kvartal -editable 0 -label "  " -width 2 \
                -values {1 2 3 4} \
                -textvariable ${REP}(head_kvartal) \
                -helptext "   "] -side left
        pack [label $hf1.l11 -text " "] -side left
        set ${REP}(head_year) $MAIN(year)
        pack [SpinBox $hf1.year -editable 0 -label "  " -width 4 \
                -side right \
                -range { 2000 2032 1 } \
                -textvariable ${REP}(head_year) \
                -helptext "   "]
    }
    
    pack [set hf5 [frame $hf2.f5 -bd 2 -relief groove]] -pady 5 -padx 5
    pack [Button $hf5.b -text $txt2 \
        -command "${Rep}:Execute $tpl"] -padx 5 -pady 2
    
    bind $tpl <Escape> "$tb.bb2 invoke 0"
    
    if [VarIn Rep Raschet Facerep] {
        Wreport:AcDeactivate {} {} $REP
    }
    
    BWidget::place $tpl 0 0 center
    wm deiconify $tpl
    
    if [VarIn Rep Platve Bankve] {
        Wreport:VidanoDay $REP
    }
}

proc Wreport:Get:YMPdr { REP } {
    global $REP
    set pdr_cod -1
    set m [GetMonthInt [lindex [subst $${REP}(head_tmonth_year)] 0]]
    set y [lindex [subst $${REP}(head_tmonth_year)] 1]
    if [info exists ${REP}(pdrwindow)] {
        if { [set idx [[subst $${REP}(pdrwindow)] getvalue]] != -1 } {
            set pdr_cod [lindex [subst $${REP}(lpdr_cod)] $idx]
        }
    }
    return "$y $m $pdr_cod"
}

proc Wreport:HeSot { w REP } {
    global $REP
    Lindexes [Wreport:Get:YMPdr $REP] y m pdr_cod
    set heret [He $REP [subst $${REP}(sotwindow)] -width 50 \
                   -find [subst $${REP}(head_sot_fio)] \
                   -side top -anchor w \
                   -title " " \
                   -labels {  50 } \
                   -query "select distinct a.fio as sot_fio, a.cod as sot_cod \
                               from sot a join sotdol as b on a.cod = sot_cod and \
                                               b.dt < '[GetFirstDayNextMonth $m $y]' and \
                                               ( b.du is null or b.du > '01.$m.$y' ) \
                                          join dol as c on b.dol_cod = c.cod and \
                                               c.pdr_cod = $pdr_cod \
                               where \[Construct a.fio \${wdd}HE(find)\] \
                               order by a.fio"]
     Lindexes $heret ${REP}(head_sot_fio) ${REP}(head_sot_cod)
}

proc Wreport:AcDeactivate { wm wcfg REP } {
    global $REP
    if [IsBe wm] { focus $wm }
    if [info exists ${REP}(pdrwindow)] {
        [subst $${REP}(pdrwindow)] configure -state disabled
    }
    if [info exists ${REP}(sotwindow)] {
        [subst $${REP}(sotwindow)] configure -state disabled
    }
    if [IsBe wcfg] { $wcfg configure -state normal }
}

proc Wreport:Dat { REP } {
    global $REP
    [subst $${REP}(monthyearwindow)] configure \
        -values [YearAmongMonth [subst $${REP}(head_tmonth_year)]]
    set ${REP}(head_sot_cod) ""
    set ${REP}(head_sot_fio) ""
}

proc Wreport:VidanoDay { REP } {
    global $REP MAIN
    
    BeforeQuery $REP "   ... "
    Lindexes [Wreport:Get:YMPdr $REP] y m pdr_cod
    set ${REP}(lday) {}
    dpg_select .rn $MAIN(iddbs) \
        "select distinct date_part('day',datvidano) as dat
            from vidano
            where datvidano >= '01.$m.$y' and
                  datvidano < '[GetFirstDayNextMonth $m $y]'
            order by dat
        " A {
        lappend ${REP}(lday) $A(dat)
        incr ${REP}(progress)
    } 
    AfterQuery $REP
    [subst $${REP}(daywindow)] configure -values [subst $${REP}(lday)]
    if { [lsearch -exact [subst $${REP}(lday)] $MAIN(day)] != -1 } {
        set ${REP}(head_day) $MAIN(day)
    } else {
        set ${REP}(head_day) [lindex [subst $${REP}(lday)] 0]
    }
}

proc Wreport:Pdr { REP } {
    global $REP
    set ${REP}(head_sot_cod) ""
    set ${REP}(head_sot_fio) ""
}

