proc Bankve:Execute { tpl } {
    global BANKVE
    Lindexes [Wreport:Get:YMPdr BANKVE] y m pdr_cod
    switch -exact -- $BANKVE(radio) {
        0 {
            set where "b.dt < '[GetFirstDayNextMonth $m $y]' and
                       ( b.du is null or b.du > '01.$m.$y' )"
        }
        1 {
            set where "c.pdr_cod = $pdr_cod and
                      b.dt < '[GetFirstDayNextMonth $m $y]' and
                      ( b.du is null or b.du > '01.$m.$y' )"
        }
    }
    set unwhere ""
    Bankve:Report $tpl BANKVE $BANKVE(head_tmonth_year) $y $m $BANKVE(head_day) \
        $where $unwhere
}


proc Bankve:Report { tpl glv tmonthyear y m d where unwhere } {
    global MAIN $glv

    set query "select a.pdr_nam, a.fio, sum(b.summa) as summa, '' as un_nam,
                      a.bank_schet
                  from (select distinct on (a.cod) a.cod as sot_cod, a.fio, 
                               d.nam as pdr_nam, a.bank_schet
                          from sot a, sotdol b, dol c, strorg d
                          where a.cod = b.sot_cod and
                                b.dol_cod = c.cod and
                                c.pdr_cod = d.cod and
                                $where) a,
                       vidano b
                  where a.sot_cod = b.sot_cod and
                        b.datvidano = '$d.$m.$y'
                  group by a.pdr_nam, a.fio, a.bank_schet"

    if { [regexp "c\\.pdr_cod" $where] == 0 } {
        set rep bankveorg
    } else {
        if [IsBe unwhere] {
            set query "select a.pdr_nam, a.fio, sum(b.summa) as summa, c.nam as un_nam,
                              a.bank_schet
                          from (select distinct on (a.cod) a.cod as sot_cod, a.fio, 
                                       d.nam as pdr_nam, a.bank_schet
                                  from sot a, sotdol b, dol c, strorg d
                                  where a.cod = b.sot_cod and
                                        b.dol_cod = c.cod and
                                        c.pdr_cod = d.cod and
                                        $where) a,
                               vidano b, un c
                          where a.sot_cod = b.sot_cod and
                                b.datvidano = '$d.$m.$y' and
                                b.un_cod = c.cod and
                                $unwhere
                          group by a.pdr_nam, a.fio, c.nam, a.bank_schet"
            set rep bankvepdrv
        } else {
            set rep bankvepdr
        }
    }
    
    if ![MessageDlg $tpl.dlg -buttons { } -icon question -type user -message "  ?" -default 0] {
        BeforeQuery $glv "   ... "
        report start $rep
        set i 0
        dpg_select $tpl $MAIN(iddbs) $query A {
            report output $d $tmonthyear [cnvs $A(pdr_nam)] [cnvs $A(fio)] \
                $A(summa) [cnvs $A(un_nam)] $A(bank_schet)
            ProgressIncr ${glv}(progress) [incr i] 10
        }
        PrintDoc $tpl " " [report stop]
        AfterQuery $glv
    }
}

