encoding system cp1251
option readfile Options

global MAIN env

set MAIN(DBSServer)     localhost
set MAIN(DBSPort)       5432
set MAIN(DBSName)       dpay
set MAIN(User)          doro
set MAIN(Passwd)        qwe123
set MAIN(Printer)       $env(PRINTER)
set MAIN(Printcmd)      $env(PRINTCMD)

load "/usr/local/pgsql/lib/libpgtcl.so"
package require -exact Tktable 2.7
package require BWidget
package require Extral
package require mclistbox
namespace import mclistbox::mclistbox

DynamicHelp::configure -bg yellow2 -delay 300 -fg blue

# include resource files
foreach i { report  printdoc    lib     menu        rn      rn_q
            cal     cal_q       un      un_q        unr     unz
            unr_q   unz_q       strorg  strorg_q    dol     dol_q
            he      sot         sot_q   sott        sott_q  soti 
            soti_q  sotp        sotp_q  sotu        sotu_q 
            tabel   tabel_q     stat    stat_q      naznach sotunzk sotunzk_q
            sotunk  sotunk_q    sotunz  sotunz_q    shablonunk
            shablonunk_q        shablonunz          shablonunz_q 
            unsotzk unsotk      unsotz  unsotzk_q   unsotk_q    
            unsotz_q            raschet_q   vidano  vidano_q 
            face    face_q      faceunv faceunv_q   wreport 
            help    svodun_q    platve_q    bankve_q    vidanosot 
            f8dr_q } {
    uplevel #0 [list source $i.tcl]
}

rename pack packnew
global LWCR
set LWCR 0
proc pack { args } {
    global LWCR
    eval packnew $args
    incr LWCR 
}

namespace import Report::*

# Init pictures
foreach i { cursheet printer next   prev copyright quit     save  paste  cut
            minus    minusG  minusR plus plusG     plusR    watch ukdown 
            waiting  help } {
    image create photo $i -file [file join .. icons $i.gif]
}

InitWidgets

#    ###########################################################
set x [lindex [wm maxsize .] 0]
wm geometry . =${x}x25+0+0
wm title . " "
pack [frame .f -bd 1 -relief raised] -side top -fill x

while 1 {
    if { ![IsBe MAIN(iddbs)] || $MAIN(iddbs) == -1 } { 
        PasswdDlg .pwddlg -logintextvariable MAIN(User) \
            -passwdtextvariable MAIN(Passwd) \
            -title "    "
        set MAIN(iddbs) [dpg_connect . -conninfo "dbname=$MAIN(DBSName) \
                                                  host=$MAIN(DBSServer) \
                                                  port=$MAIN(DBSPort) \
                                                  user=$MAIN(User) \
                                                  password=$MAIN(Passwd)"]
    } else break
}

Menu
pg_exec $MAIN(iddbs) "set client_encoding to 'win'"
pg_exec $MAIN(iddbs) "set datestyle to 'german'"
Stat:Sel

#Rn
#Un 1
#Strorg
#Sot
#Stat
#Tabel
#Naznach Sot Un
#Naznach Un Sot
#Vidano
#Face
#Wreport Raschet
#Wreport Svodun
#Wreport Platve
#Wreport Bankve
#Wreport F8dr

