proc Rn:Sel { w } {
    global RN MAIN
    BeforeQuery RN "   ... "
    $w delete 0 end
    tonull RN(cod) RN(nam)
    
    set i 0
    set query "select * from rn a where [cnvi $RN(find)] order by a.nam"
    dpg_select .rn $MAIN(iddbs) $query A {
        $w insert end [list [cnvs $A(nam)] $A(cod)]
        ProgressIncr RN(progress) [incr i] 20
    } 
    
    AfterQuery RN
    SelectionActivateSee $w 0
    Rn:Import:Attr $w
    focus $w
}

proc Rn:Ins { w } {
    global RN MAIN
    if [IsBe RN(nam)] {
        BeforeQuery RN "   ... "
        set query "select rn_ins('[cnvi $RN(nam)]') as cod"
        dpg_select .rn $MAIN(iddbs) $query A {
            $w insert end [list $RN(nam) $A(cod)]
            incr RN(progress)
            SelectionActivateSee $w end
            Rn:Import:Attr $w
        }
        AfterQuery RN
    }
}

proc Rn:Del { w } {
    global RN MAIN
    if [IsBe RN(cod)] {
        if ![MessageDlg .rn.dlg -buttons { } -icon question -type user -message " ?\n\"$RN(nam)\"" -default 0] {
            BeforeQuery RN "   ... "
            set query "select rn_del('$RN(cod)') as cod"
            set idx [$w index active]
            dpg_select .rn $MAIN(iddbs) $query A {
                $w delete $idx $idx
                incr RN(progress)
                SelectionActivateSee $w active
                Rn:Import:Attr $w
            }
            AfterQuery RN
        }
    }
}

proc Rn:Upd { w } {
    global RN MAIN
    if ![MessageDlg .rn.dlg -buttons { } -icon question -type user -message " ?\n\"$RN(nam)\"" -default 0] {
        BeforeQuery RN "   ... "
        set query "select rn_upd('$RN(cod)','[cnvi $RN(nam)]') as cod"
        set idx [$w index active]
        dpg_select .rn $MAIN(iddbs) $query A {
            $w delete $idx $idx
            $w insert $idx [list $RN(nam) $RN(cod)]
            incr RN(progress)
            SelectionActivateSee $w $idx
        }
        AfterQuery RN
    }
}

proc Rn:Print { w } {
    global MAIN CAL_DATA CAL RN
    if ![MessageDlg .rn.dlg -buttons { } -icon question -type user -message "  ?" -default 0] {
        BeforeQuery RN "   ... "
        report start rn
        set query "select a.nam, 
                          date_part('year',b.dat) as y, 
                          date_part('month',b.dat) as m, 
                          b.dk, b.d, b.h
                      from rn a, cal b
                      where a.cod = b.rn_cod and
                            date_part('year',b.dat) = '$CAL(year)' and 
                            [cnvi $RN(find)]
                      order by a.nam, y, m"
        set i 0
        dpg_select .rn $MAIN(iddbs) $query A {    
            report output [cnvs $A(nam)] $A(y) \
                $CAL_DATA([expr $A(m) - 1],0) \
                $A(dk) $A(d) $A(h)
            ProgressIncr RN(progress) [incr i] 4
        }
        PrintDoc .rn "    $CAL(year) " [report stop]
        AfterQuery RN
    }
}

proc Rn:Find { w } {
    global RN
    if ![MessageDlg .rn.dlg -buttons { } -icon question -type user \
        -message "  \n\"$RN(nam)\" ?" -default 0] {
        set RN(find) [Construct a.nam RN(nam)]
        Rn:Sel $w
    }
}
