proc Shablonunk:Query {} {
    return "select a.cod as un_cod, a.nam as un_nam,
                   b.un_cod as s_cod, b.summa
                from un a left outer join shablon as b on b.un_cod = a.cod
                where a.vid = 'k'
                order by a.tip desc, a.nam"
}

proc Shablonunk:Sel { w } {
    global MAIN SHABLONUNK SHABLONUNK_DATA SHABLONUNK_OLDDATA
    BeforeQuery SHABLONUNK "   ... "
    Unset SHABLONUNK_DATA SHABLONUNK_OLDDATA
    set SHABLONUNK_DATA(-1,0) "/"
    set SHABLONUNK_DATA(-1,1)  ""
    set wtbl $SHABLONUNK(tblwindow)
    set titrows [$wtbl cget -titlerows]
    set i 0
    
    dpg_select $w $MAIN(iddbs) [Shablonunk:Query] A {
        set SHABLONUNK_DATA($i,un_cod) $A(un_cod)
        set SHABLONUNK_DATA($i,0)      [cnvs $A(un_nam)]
        set SHABLONUNK_DATA($i,s_cod)  $A(s_cod)
        set SHABLONUNK_DATA($i,1)      $A(summa)
        ProgressIncr SHABLONUNK(progress) [incr i] 4
    }
    
    array set SHABLONUNK_OLDDATA [array get SHABLONUNK_DATA]
    if { $i > [expr [$wtbl cget -rows] - $titrows] } {
        $wtbl configure -rows [expr $i + $titrows]
    } else {
        $wtbl configure -rows [$wtbl cget -height]
    }
    AfterQuery SHABLONUNK
    focus $wtbl
}

proc Shablonunk:Write { w row } {
    global SHABLONUNK_DATA SHABLONUNK_OLDDATA
    if [IsBe SHABLONUNK_DATA($row,s_cod)] {
        if { $SHABLONUNK_DATA($row,1) != $SHABLONUNK_OLDDATA($row,1) &&
             [IsBe SHABLONUNK_DATA($row,1)] } {
            Shablonunk:Upd $w $row
        } elseif { $SHABLONUNK_DATA($row,1) != $SHABLONUNK_OLDDATA($row,1) &&
                   ![IsBe SHABLONUNK_DATA($row,1)] } {
            Shablonunk:Del $w $row
        }
    } else {
        if [IsBe SHABLONUNK_DATA($row,1)] {
            Shablonunk:Ins $w $row
        }
    }
}

proc Shablonunk:Ins { w row } {
    global SHABLONUNK_DATA SHABLONUNK_OLDDATA MAIN SHABLONUNK
    set wtbl $SHABLONUNK(tblwindow)
    if [IsBe SHABLONUNK_DATA($row,un_cod)] {
        BeforeQuery SHABLONUNK "   $row ... "
        set query "select shablon_ins('$SHABLONUNK_DATA($row,un_cod)',
                                      '$SHABLONUNK_DATA($row,1)') as cod"
        set err [dpg_select $w $MAIN(iddbs) $query A {
            set SHABLONUNK_DATA($row,s_cod) $SHABLONUNK_DATA($row,un_cod)
            incr SHABLONUNK(progress)
        }]
        if { $err == -1 } {
            $wtbl tag row Error $row
        } else {
            set SHABLONUNK_OLDDATA($row,s_cod) $SHABLONUNK_DATA($row,s_cod)
            set SHABLONUNK_OLDDATA($row,1)     $SHABLONUNK_DATA($row,1)
            $wtbl tag row [TkTableRowTagCmd $row] $row
        }
        AfterQuery SHABLONUNK
    }
}

proc Shablonunk:Upd { w row } {
    global SHABLONUNK_DATA SHABLONUNK_OLDDATA MAIN SHABLONUNK
    set wtbl $SHABLONUNK(tblwindow)
    BeforeQuery SHABLONUNK "   $row ... "
    set query "select shablon_upd('$SHABLONUNK_DATA($row,s_cod)',
                                  '$SHABLONUNK_DATA($row,1)') as cod"
    set err [dpg_select $w $MAIN(iddbs) $query A {
        incr SHABLONUNK(progress)
    }]
    if { $err == -1 } {
        $wtbl tag row Error $row
    } else {
        set SHABLONUNK_OLDDATA($row,1) $SHABLONUNK_DATA($row,1)
        $wtbl tag row [TkTableRowTagCmd $row] $row
    }
    AfterQuery SHABLONUNK
}

proc Shablonunk:Del { w row } {
    global SHABLONUNK_DATA SHABLONUNK_OLDDATA MAIN SHABLONUNK
    set wtbl $SHABLONUNK(tblwindow)
    if ![IsBe row] { set row [$wtbl index active row] }
    if [IsBe SHABLONUNK_DATA($row,s_cod)] {
        if ![MessageDlg $w.dlg -buttons { } -icon question -type user -message "  $row ?" -default 0] {
            BeforeQuery SHABLONUNK "   $row ... "
            set query "select shablon_del('$SHABLONUNK_DATA($row,s_cod)') as cod"
            set err [dpg_select $w $MAIN(iddbs) $query A {
                incr SHABLONUNK(progress)
            }]
            if { $err == -1 } {
                $wtbl tag row Error $row
            } else {
                set SHABLONUNK_DATA($row,1) ""
                Unset SHABLONUNK_DATA($row,s_cod) SHABLONUNK_DATA($row,1)
                $wtbl tag row CurrentRow $row
            }
            AfterQuery SHABLONUNK
        }
    }
}

proc Shablonunk:Get { tpl } {
    global MAIN
    set ret {}
    dpg_select $tpl $MAIN(iddbs) [Shablonunk:Query] A {
        lappend ret [list $A(un_cod) $A(summa)]
    }
    return $ret
}