proc Sot:Sel { w } {
    global SOT MAIN
    BeforeQuery SOT "    ... "
    $w delete 0 end
    tonull SOT(tn) SOT(fio) SOT(bank_schet) SOT(inn)
    
    set i 0
    set query "select * from sot a where [cnvi $SOT(find)] order by a.tn"
    dpg_select .sot $MAIN(iddbs) $query A {
        $w insert end [list $A(tn) [cnvs $A(fio)] $A(cod) [cnvs $A(bank_schet)] \
                            [cnvs $A(inn)] $A(sto) $A(stn) $A(stnf) $A(sts) $A(stsf)]
        ProgressIncr SOT(progress) [incr i] 20
    } 
    
    AfterQuery SOT
    SelectionActivateSee $w 0
    Sot:Import:Attr $w
    focus $w
}

proc Sot:Ins { w attr } {
    global SOT MAIN
    if [IsBe SOT(fio)] {
        if ![MessageDlg .sot.dlg -buttons { } -icon question -type user -message " ?\n\"$SOT(fio)\"" -default 0] {
            BeforeQuery SOT "   ... "
            set query "select sot_ins($SOT(tn), '[cnvi $SOT(fio)]', \
                                      '[cnvi $SOT(bank_schet)]', '[cnvi $SOT(inn)]', \
                                      $SOT(sto), $SOT(stn), '$SOT(stnf)', \
                                      $SOT(sts), '$SOT(stsf)') as cod"
            dpg_select .sot $MAIN(iddbs) $query A {
                $w insert end [list $SOT(tn) $SOT(fio) $A(cod) $SOT(bank_schet) \
                                    $SOT(inn) $SOT(sto) $SOT(stn) $SOT(stnf) \
                                    $SOT(sts) $SOT(stsf)]
                incr SOT(progress)
                SelectionActivateSee $w end
                Sot:Import:Attr $w
                focus $attr.tn
            }
            AfterQuery SOT
            incr SOT(tn)
            tonull SOT(fio) SOT(bank_schet) SOT(inn) SOT(sto) SOT(stn) SOT(sts) SOT(stnf) SOT(stsf)
        }
    }
    
}

proc Sot:Del { w attr } {
    global SOT MAIN
    if [IsBe SOT(cod)] {
        if ![MessageDlg .sot.dlg -buttons { } -icon question -type user -message " ?\n\"$SOT(fio)\"" -default 0] {
            BeforeQuery SOT "   ... "
            set query "select sot_del('$SOT(cod)') as cod"
            set idx [$w index active]
            dpg_select .sot $MAIN(iddbs) $query A {
                $w delete $idx $idx
                incr SOT(progress)
                SelectionActivateSee $w active
                Sot:Import:Attr $w
            }
            AfterQuery SOT
        }
    }
}

proc Sot:Upd { w attr } {
    global SOT MAIN
    if ![MessageDlg .sot.dlg -buttons { } -icon question -type user -message " ?\n\"$SOT(fio)\"" -default 0] {
        BeforeQuery SOT "   ... "
        set query "select sot_upd($SOT(cod), $SOT(tn), \
                                  '[cnvi $SOT(fio)]', '[cnvi $SOT(bank_schet)]', \
                                  '[cnvi $SOT(inn)]', \
                                  $SOT(sto), $SOT(stn), '$SOT(stnf)', $SOT(sts), '$SOT(stsf)') as cod"
        set idx [$w index active]
        dpg_select .sot $MAIN(iddbs) $query A {
            $w delete $idx $idx
            $w insert $idx [list $SOT(tn) $SOT(fio) $SOT(cod) $SOT(bank_schet) \
                                $SOT(inn) $SOT(sto) $SOT(stn) $SOT(stnf) \
                                $SOT(sts) $SOT(stsf)]
            incr SOT(progress)
            SelectionActivateSee $w $idx
        }
        AfterQuery SOT
    }
}

proc Sot:Print { w } {
    global MAIN SOT
    if ![MessageDlg .sot.dlg -buttons { } -icon question -type user -message "  ?" -default 0] {
        BeforeQuery SOT "   ... "
        report start sot
        set query "select d.nam as pdr_nam, a.tn, a.fio, a.bank_schet, a.inn, \
                          c.nam as dol_nam, b.dt, b.du, b.kd \
                      from sot a, sotdol b, dol c, strorg d \
                      where a.cod = b.sot_cod and \
                            b.dol_cod = c.cod and \
                            c.pdr_cod = d.cod \
                      order by d.nam, a.fio, b.dt"
        set i 0
        pg_select $MAIN(iddbs) $query A {    
            report output [cnvs $A(pdr_nam)] $A(tn) [cnvs $A(fio)] $A(bank_schet) \
                          $A(inn) [cnvs $A(dol_nam)] $A(dt) $A(du) $A(kd)
            ProgressIncr SOT(progress) [incr i] 4
        }
        PrintDoc .sot "" [report stop]
        AfterQuery SOT
    }
}

proc Sot:Find { w attr } {
    global SOT
    if ![MessageDlg .sot.dlg -buttons { } -icon question -type user \
            -message "  \n\"$SOT(tn)\"\n \"$SOT(fio)\"\n \"$SOT(bank_schet)\"\n \"$SOT(inn)\"\n \"$SOT(sto)\"\n \"$SOT(stn)\"\n \"$SOT(sts)\" ?" -default 0] {
        set SOT(find) [Construct a.tn a.fio a.bank_schet a.inn a.sto a.stn a.sts \
                             SOT(tn) SOT(fio) SOT(bank_schet) SOT(inn) \
                             SOT(sto) SOT(stn) SOT(sts)]
        Sot:Sel $w
    }
}
