proc SotP:ClearVar {} {
    global SOTP
    foreach i { cod dol1_nam dol2_cod dol2_nam dt kd pdr_nam rn_nam oklad tarif kom } {
        set SOTP($i) ""
    }
}

proc SotP:Sel {} {
    global SOTP MAIN SOT SOTP_DATA
    set w $SOT(frame_SotP)
    set cnt 1
    $SOTP(window_scale) configure -from 1
    if [IsBe SOT(cod)] {
        BeforeQuery SOT "     ... "
        SotP:ClearVar
        Unset SOTP_DATA
        SotP:Editable 1 $w
        set query "select a.cod, d.nam as dol1_nam \
                    from sotdol a, dol d \
                    where a.dol_cod = d.cod and \
                          a.sot_cod = '$SOT(cod)' and \
                          a.dt < '$MAIN(firstdaynextmonth)' and \
                          a.du is null \
                    order by a.dt, a.kd"
        dpg_select .sot $MAIN(iddbs) $query A {
            foreach i { cod dol1_nam } {
                lappend SOTP_DATA($i) [cnvs $A($i)]
            }
            incr SOT(progress)
            if { $cnt == 1 } { 
                foreach i { cod dol1_nam } {
                    set SOTP($i) [cnvs $A($i)]
                }
            }
            incr cnt
        }
        if { $cnt == 1 } {
            $SOTP(window_scale) configure -from 0
        }
        $SOTP(window_scale) configure -to [expr $cnt - 1]
        AfterQuery SOT
    }
    if ![IsBe SOTP(dol1_nam)] {
        SotP:Editable 0 $w
    } else {
        SotP:Editable 1 $w
    }
}

proc SotP:Ins { w } {
    global SOTP MAIN SOT
    if { [IsBe SOTP(dol2_nam)] && [IsBe SOTP(dt)] && [IsBe SOTP(cod)] } {
        if ![MessageDlg .sot.dlg -buttons { } -icon question -type user \
                -message " ?\n\"$SOT(fio)\"" -default 0] {
            BeforeQuery SOT "   ... "
            set query "select sotdolp_ins('$SOTP(cod)', '$SOT(cod)', '$SOTP(dol2_cod)', \
                                          '$SOTP(dt)', '$SOTP(kd)') as cod"
            dpg_select .sot $MAIN(iddbs) $query A {
                SotP:Sel
                focus -force $SOT(mclwindow)
            }
            AfterQuery SOT
        }
    }
}
