proc SotT:ClearVar {} {
    global SOTT
    foreach i { cod dol_nam dt kd du pdr_nam rn_nam oklad tarif kom } {
        set SOTT($i) ""
    }
}

proc SotT:Sel {} {
    global SOTT MAIN SOT SOTT_DATA
    set w $SOT(frame_SotT)
    set cnt 1
    $SOTT(window_scale) configure -from 1
    if [IsBe SOT(cod)] {
        BeforeQuery SOT "     ... "
        SotT:ClearVar
        Unset SOTT_DATA
        SotT:Editable 1 $w
        set query "select a.cod, d.nam as dol_nam, a.dt, a.kd, a.du, b.nam as pdr_nam, \
                          c.nam as rn_nam, d.oklad, d.tarif, d.kom \
                    from sotdol a, strorg b, rn c, dol d \
                    where d.pdr_cod = b.cod and \
                          a.dol_cod = d.cod and \
                          d.rn_cod = c.cod and \
                          a.sot_cod = '$SOT(cod)' and \
                          a.dt < '$MAIN(firstdaynextmonth)' and \
                          ( a.du > '01.$MAIN(month).$MAIN(year)' or \
                            a.du is null ) \
                    order by a.dt, a.kd"
        dpg_select .sot $MAIN(iddbs) $query A {
            foreach i { cod dol_nam dt kd du pdr_nam rn_nam oklad tarif kom } {
                lappend SOTT_DATA($i) [cnvs $A($i)]
            }
            incr SOT(progress)
            if { $cnt == 1 } { 
                SotT:Editable 0 $w
                foreach i { cod dol_nam dt kd pdr_nam rn_nam oklad tarif kom } {
                    set SOTT($i) [cnvs $A($i)]
                }
            }
            incr cnt
        }
        if { $cnt == 1 } {
            $SOTT(window_scale) configure -from 0
        }
        $SOTT(window_scale) configure -to [expr $cnt - 1]
        AfterQuery SOT
    }
}

proc SotT:Ins { w } {
    global SOTT MAIN SOT
    if { [IsBe SOTT(dol_nam)] && [IsBe SOTT(dt)] } {
        if ![MessageDlg .sot.dlg -buttons { } -icon question -type user \
                -message " ?\n\"$SOT(fio)\"" -default 0] {
            BeforeQuery SOT "   ... "
            set query "select sotdol_ins('$SOT(cod)', '$SOTT(dol_cod)', \
                                         '$SOTT(dt)', '$SOTT(kd)') as cod"
            dpg_select .sot $MAIN(iddbs) $query A {
                set SOTT(sotdol_cod) $A(cod)
                incr SOT(progress)
                foreach i { f1.dol dt kd } {
                    $w.$i configure -editable 0
                }
                $w.f1.ab configure -state disabled
                SotT:Sel
                focus -force $SOT(mclwindow)
            }
            AfterQuery SOT
        }
    }
}
