proc SotUnzk { w wdd vid } {
    set VID [string toupper $vid]
    global ${wdd}SOTUN${VID} ${wdd}SOTUN${VID}_DATA SOTUNZK

    # Mclistbox ###################################################################
    packef [TitleFrame $w.tf1 -text " "] -side left
    set tf1 [$w.tf1 getframe]
    pack [scrollbar $tf1.sby -command "$tf1.mcl yview"] -side right -fill y
    pack [scrollbar $tf1.sbx -command "$tf1.mcl xview" -orient hor] \
        -side bottom -fill x
    packef [mclistbox $tf1.mcl -width 46 -height 21 \
                -xscrollcommand "$tf1.sbx set" \
                -yscrollcommand "$tf1.sby set"]

    set ${wdd}SOTUN${VID}(mclwindow) $tf1.mcl
    
    $tf1.mcl column add tn         -label ".N" -width 5 -foreground magenta4
    $tf1.mcl column add fio        -label "" -width 50
    $tf1.mcl column add cod        -visible no
    
    $tf1.mcl label  bind tn          <ButtonPress-1> "SotUnzk:Sort %W tn $wdd $vid"
    $tf1.mcl label  bind fio         <ButtonPress-1> "SotUnzk:Sort %W fio $wdd $vid"
    bind $tf1.mcl  <FocusIn>         "Naznach:Activate:TF   $w.tf1"
    bind $tf1.mcl  <FocusOut>        "Naznach:DeActivate:TF $w.tf1"
    bind $tf1.mcl  <ButtonRelease-1> "focus $tf1.mcl; SotUn$vid:UnSel $wdd"
    bind $tf1.mcl  <KeyRelease-Up>   "SotUn$vid:UnSel $wdd"
    bind $tf1.mcl  <KeyRelease-Down> "SotUn$vid:UnSel $wdd"
    bind $tf1      <Map>             "SotUnzk:SotSel $wdd $vid"

    SotUn${vid}:Tbl $w $wdd

    # Shablon ######################################################################
    pack [frame $w.f.sh -bd 2 -relief groove] -side bottom -padx 2 -pady 2 -anchor se
    pack [Button $w.f.sh.b1 -text " " \
            -takefocus 0 \
            -helptext "     \n  " \
            -command "Shablonun${vid}:Create $SOTUNZK(tpl)"] -side left -pady 1 -padx 3
    pack [Button $w.f.sh.b2 -text " " \
            -takefocus 0 \
            -helptext "    \n    " \
            -command "SotUn${vid}:Shablon $SOTUNZK(tpl) $wdd"] -side left -pady 1 -padx 3
}

proc SotUnzk:Sort { w fld wdd vid } {
    Mclistbox:Sort $w $fld
    SotUn$vid:UnSel $wdd
}
