proc Stat:Sel {} {
    global STAT STAT_DATA STAT_OLDDATA MAIN
    Unset STAT_DATA STAT_OLDDATA
    set STAT_DATA(-1,-1) ""
    set STAT_DATA(-1,0)  "   "
    set STAT_DATA(0,-1)  "  "
    set STAT_DATA(1,-1)  "  "
    set STAT_DATA(2,-1)  ""
    set STAT_DATA(3,-1)  ""
    set STAT_DATA(4,-1)  ""

    BeforeQuery STAT "   ... "
    set query "select a.cod, b.cod as un_cod, b.nam as un_nam \
                   from stat a, un b \
                   where a.un_cod = b.cod"
    dpg_select .stat $MAIN(iddbs) $query A {
        set STAT_DATA($A(cod),un_cod) $A(un_cod)
        set STAT_DATA($A(cod),0)      [cnvs $A(un_nam)]
        incr STAT(progress)
    }
    array set STAT_OLDDATA [array get STAT_DATA]
    AfterQuery STAT
}

proc Stat:Ins { w row } {
    global STAT_DATA STAT MAIN STAT_OLDDATA
    if { [IsBe STAT_DATA($row,un_cod)] && 
         (![IsBe STAT_OLDDATA($row,un_cod)] ||
           $STAT_OLDDATA($row,un_cod) != $STAT_DATA($row,un_cod))} {
        BeforeQuery STAT "   $row ... "
        set query "select stat_ins($row, $STAT_DATA($row,un_cod)) as cod"
        set err [dpg_select .stat $MAIN(iddbs) $query A {
            incr STAT(progress)
        }]
        if { $err == -1 } {
            $w tag row Error $row
        } else {
            set STAT_OLDDATA($row,un_cod) $STAT_DATA($row,un_cod)
            set STAT_OLDDATA($row,0)      $STAT_DATA($row,0)
            $w tag row [TkTableRowTagCmd $row] $row
        }
        AfterQuery STAT
    }
}

proc Stat:Get { un_cod } {
    global STAT_DATA
    for { set i 0 } { $i < 5 } { incr i } {
        if { $STAT_DATA($i,un_cod) == $un_cod } { return $i }
    }    
    return -1
}

proc Stat:Get:Cod { row } {
    global STAT_DATA
    if [IsBe STAT_DATA($row,un_cod)] { return $STAT_DATA($row,un_cod) }
    return -1
}
