proc Unr { tf wddun w vid } {
    set wdd [DelDot $w]
    global UN ${wdd}UNR ${wdd}UNR_DATA
    Unset ${wdd}UNR
    
    pack [frame $w.f -bd 1 -relief sunken] -anchor sw  -pady 2 -padx 3
    pack [scrollbar $w.f.sby -command "$w.f.tbl yview"] -side right -fill y
    pack [table $w.f.tbl -width 4 -height 14 -cols 4 -rows 14 -relief flat \
        -yscrollcommand "$w.f.sby set" \
        -browsecommand "Unr:Tbl:Browsecommand $wddun $w.f.tbl $wdd $vid" \
        -rowtagcommand { TkTableRowTagCmd } \
        -variable ${wdd}UNR_DATA \
        -titlerows 2 \
        -roworigin -2 \
        -colorigin 0] -side left

    TkTableInitTag $w.f.tbl
    TkTableInitBind $w.f.tbl
    
    $w.f.tbl width 0 9  1 9  2 9  3 9
    $w.f.tbl tag col AnchorE 0 1 2 3
    
    if [VarIn vid s] {
        $w.f.tbl spans -2,0 0,2 -2,3 1,0
    } else {
        $w.f.tbl spans -2,0 0,1 -2,2 1,0 -2,3 1,0
    }
    
    bind $w       <FocusIn>  "Un:Activate:TF   $tf; set ${wddun}UN(lastfocus) $w.f.tbl"
    bind $w       <FocusOut> "Un:DeActivate:TF $tf"
    bind $w.f.tbl <F8>       "Unr:Del $wddun $w.f.tbl $wdd $vid {}"
    DynamicHelp::register $w.f.tbl balloon "  , ,  "
    set ${wdd}UNR(tblwindow) $w.f.tbl
}

proc Unr:Tbl:Browsecommand { wddun w wdd vid } {
    global ${wdd}UNR ${wdd}UNR_DATA
    set active [$w index active]
    if ![IsBe ${wdd}UNR(oldactive)] { set ${wdd}UNR(oldactive) $active }
    scan [TkTableNotActiveDisabled $w [subst $${wdd}UNR(oldactive)] $active] \
         "%s%s%s%s%s%s" oldactive active oldrow row oldcol col

    set idxwrt [$w index $oldactive row]
    if { [$w index $active row] != $idxwrt } {
        Unr:Write $idxwrt $wddun $w $wdd $vid
    }
    
    if { [$w tag row Error] != $oldrow } {
        $w tag row [TkTableRowTagCmd $oldrow] $oldrow
    }
    $w tag row CurrentRow $row
    set ${wdd}UNR(oldactive) $active
}

