proc UnSotz:Tbl { w wdd } {
    global ${wdd}UNSOTZ ${wdd}UNSOTZ_DATA

    pack [frame $w.f] -side right -fill y
    pack [TitleFrame $w.f.tf2 -text "   "] \
        -side top -anchor n
    set tf2 [$w.f.tf2 getframe]
    pack [frame $tf2.f -bd 1 -relief sunken] -anchor n
    pack [scrollbar $tf2.f.sby -command "$tf2.f.tbl yview"] -side right -fill y
    pack [table $tf2.f.tbl -width 2 -height 19 -cols 2 -rows 2 -relief flat \
        -yscrollcommand "$tf2.f.sby set" \
        -browsecommand "UnSotz:Tbl:Browsecommand %W $wdd" \
        -rowtagcommand { TkTableRowTagCmd } \
        -variable ${wdd}UNSOTZ_DATA \
        -titlerows 2 \
        -roworigin -2 \
        -colorigin 0]

    TkTableInitTag $tf2.f.tbl
    
    $tf2.f.tbl width 0 50  1 11
    $tf2.f.tbl tag col Disabled 0
    $tf2.f.tbl spans -2,0 1,0 -2,1 1,0
    
    bind $tf2        <FocusIn>      "Naznach:Activate:TF   $w.f.tf2"
    bind $tf2        <FocusOut>     "Naznach:DeActivate:TF $w.f.tf2"
    bind $tf2.f.tbl  <Return>       "UnSotz:Tbl:Bind:Return $wdd $tf2.f.tbl"
    bind $tf2.f.tbl  <KP_Enter>     "UnSotz:Tbl:Bind:Return $wdd $tf2.f.tbl"
    bind $tf2.f.tbl  <FocusIn> {
        if { [set row [%W tag row CurrentRow]] == "" } {
            set row 0
        }
        %W activate $row,1
        %W see $row,1
        %W.b$row configure -bg [option get %W currentBackground Table]
    }
    set ${wdd}UNSOTZ(tblwindow) $tf2.f.tbl
}

proc UnSotz:Tbl:Bind:Return { wdd w } {
    UnSotz:Tbl:Bind:Lbl $wdd $w [$w index active row]
}

proc UnSotz:Tbl:Browsecommand { w wdd } {
    global ${wdd}UNSOTZ
    set active [$w index active]
    if ![IsBe ${wdd}UNSOTZ(oldactive)] { set ${wdd}UNSOTZ(oldactive) $active }
    scan [TkTableNotActiveDisabled $w [subst $${wdd}UNSOTZ(oldactive)] $active] \
         "%s%s%s%s%s%s" oldactive active oldrow row oldcol col
    
    $w tag row [TkTableRowTagCmd $oldrow] $oldrow
    $w tag row CurrentRow $row
    $w.b$row configure -bg [option get $w currentBackground Table]
    if { $oldrow != $row } {
        $w.b$oldrow configure -bg [option get $w [TkTableRowTagCmd $oldrow] Table]
    }
    set ${wdd}UNSOTZ(oldactive) $active
}
