proc Unz { tf wddun w vid } {
    set wdd [DelDot $w]
    global UN ${wdd}UNZ ${wdd}UNZ_DATA
    Unset ${wdd}UNZ
    
    pack [frame $w.f -bd 1 -relief sunken] -anchor s -pady 2 -padx 3
    pack [scrollbar $w.f.sby -command "$w.f.tbl yview"] -side right -fill y
    pack [table $w.f.tbl -width 2 -height 14 -cols 2 -rows 2 -relief flat \
        -yscrollcommand "$w.f.sby set" \
        -browsecommand "Unz:Tbl:Browsecommand %W $wdd" \
        -rowtagcommand { TkTableRowTagCmd } \
        -variable ${wdd}UNZ_DATA \
        -titlerows 2 \
        -roworigin -2 \
        -colorigin 0]

    TkTableInitTag $w.f.tbl
    
    $w.f.tbl width 0 30  1 10
    $w.f.tbl tag col Disabled 0
    $w.f.tbl spans -2,0 1,0 -2,1 1,0
    
    bind $w        <FocusIn>             "Un:Activate:TF   $tf; set ${wddun}UN(lastfocus) $w.f.tbl"
    bind $w        <FocusOut>            "Un:DeActivate:TF $tf"
    bind $w.f.tbl  <Return>              "Unz:Tbl:Bind:Return $wddun $wdd $w.f.tbl $vid"
    bind $w.f.tbl  <KP_Enter>            "Unz:Tbl:Bind:Return $wddun $wdd $w.f.tbl $vid"
    bind $w.f.tbl  <FocusIn> {
        if { [set row [%W tag row CurrentRow]] == "" } {
            set row 0
        }
        %W activate $row,1
        %W see $row,1
        %W.b$row configure -bg [option get %W currentBackground Table]
    }
    set ${wdd}UNZ(tblwindow) $w.f.tbl
}

proc Unz:Tbl:Bind:Return { wddun wdd w vid } {
    Unz:Tbl:Bind:Lbl $wddun $wdd $w [$w index active row] $vid
}

proc Unz:Tbl:Browsecommand { w wdd } {
    global ${wdd}UNZ ${wdd}UNZ_DATA
    set active [$w index active]
    if ![IsBe ${wdd}UNZ(oldactive)] { set ${wdd}UNZ(oldactive) $active }
    scan [TkTableNotActiveDisabled $w [subst $${wdd}UNZ(oldactive)] $active] \
         "%s%s%s%s%s%s" oldactive active oldrow row oldcol col
    
    $w tag row [TkTableRowTagCmd $oldrow] $oldrow
    $w tag row CurrentRow $row
    $w.b$row configure -bg [option get $w currentBackground Table]
    if { $oldrow != $row } {
        $w.b$oldrow configure -bg [option get $w [TkTableRowTagCmd $oldrow] Table]
    }
    set ${wdd}UNZ(oldactive) $active
}

